﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@
'version 1.10
#Event: ActionClicked (Index As Int, ActionText As String)
Sub Class_Globals
	Private mCLV As CustomListView
	Type SwipeItem (Value As Object, leftActions As List, rightActions As List, _ 
	IsLeftSwiped As Boolean, IsRightSwiped As Boolean, leftMaxSwipe As Int, rightMaxSwipe As Int, _  
	leftOpen As Boolean, rightOpen As Boolean)
	Public Base As B4XView
	Private TouchXStart, TouchYStart As Float
	Private HandlingSwipe As Boolean
	Private ActionsPanel As B4XView
	Private LastSwipedItem As Int = -1
	Public ActionColors As Map
	Private xui As XUI
	Private cvs As B4XCanvas
	Private mCallback As Object
	Private mEventName As String
	Private mPullToRefreshPanel As B4XView
	Private PullToRefreshSwipe As Boolean 'ignore
	Private WaitingForRefreshToComplete As Boolean
	Private EntryLeft As Int
	'Wong Ka Chun added this variable on 2019-08-14
	'left:	 {index: -1}
	'middle: {index: 0} 
	'right:	 {index: 1}
	Private mapMode As Map
End Sub

Public Sub Initialize (clv As CustomListView, Callback As Object, EventName As String)
	#if B4A
	Dim creator As TouchPanelCreator
	Base = creator.CreateTouchPanel("TouchPanel")
	#else if B4i
	Base = xui.CreatePanel("")
	Dim nme As NativeObject = Me
	Dim no As NativeObject = Base
	no.RunMethod("addGestureRecognizer:", Array(nme.RunMethod("CreateRecognizer", Null)))
	#end if
	ActionsPanel = xui.CreatePanel("")
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, 1dip, 1dip)
	cvs.Initialize(p)
	mCLV = clv
	mCLV.AsView.Parent.AddView(Base, mCLV.AsView.Left, mCLV.AsView.Top, mCLV.AsView.Width, mCLV.AsView.Height)
	mCLV.AsView.RemoveViewFromParent
	Base.AddView(mCLV.AsView, 0, 0, Base.Width, Base.Height)	
	mCallback = Callback
	mEventName = EventName
	mapMode.Initialize
End Sub

Public Sub CreateItemValue(Value As Object, lActions As List, rActions As List) As SwipeItem
	Dim m As SwipeItem
	m.Initialize
	m.Value = Value
	m.leftActions = lActions
	m.rightActions = rActions
	Return m
End Sub

Private Sub ChangeRightOffset(index As Int, dx As Int, complete As Boolean) As Boolean
	If index < 0 Or index >= mCLV.Size Then 
		LogColor("ChangeRightOffset: Return False 1", Colors.Red)
		Return False
	End If
	Dim item As CLVItem = mCLV.GetRawListItem(index)
	If Not(item.Value Is SwipeItem) Then 
		LogColor("ChangeRightOffset: Return False 2", Colors.Red)
		Return False
	End If
	Dim m As SwipeItem = item.Value
	If m.IsRightSwiped = False And complete = True Then 
		LogColor("ChangeRightOffset: Return False 3", Colors.Red)
		Return False
	End If
	If m.IsRightSwiped = False Then
		If m.rightActions.IsInitialized And m.rightActions.Size > 0 Then
			m.IsRightSwiped = True
			'Reset another side
			m.IsLeftSwiped = False
			If ActionsPanel.Parent.IsInitialized Then ActionsPanel.RemoveViewFromParent
			item.Panel.Parent.AddView(ActionsPanel, 0, item.Panel.Top, item.Panel.Width, item.Panel.Height)
			ActionsPanel.SendToBack
			m.rightMaxSwipe = CreateRightActionButtons(m.rightActions)
			LastSwipedItem = index
		Else
			LogColor("ChangeRightOffset: Return False 4", Colors.Red)
			Return False
		End If
	End If
	EntryLeft = Max(Min(item.Panel.Left + dx, 0), -m.rightMaxSwipe)
	'LogColor($"EntryLeft: ${EntryLeft}; is completed? ${complete}"$, Colors.Blue)
	If complete Then
		'LogColor($"index: ${index} - ChangeRightOffset's complete: "$, Colors.Red)
		If LastSwipedItem <> -1 Then
			If mapMode.ContainsKey(LastSwipedItem) = False Then
				Return False
			End If
			Dim intMode As Int = mapMode.Get(LastSwipedItem)
			If intMode = 1 Then
				If	(m.RightOpen = False And EntryLeft >= -40dip) Or (m.RightOpen = True And EntryLeft >= -m.RightMaxSwipe + 10dip) Then
					'sliding the panel to left as 0
					'LogColor($"...sliding back with index ${index}"$, Colors.Magenta)
					item.Panel.SetLayoutAnimated(200, 0, item.Panel.Top, item.Panel.Width, item.Panel.Height)
					m.IsRightSwiped = False
					m.RightOpen = False
					mapMode.Put(LastSwipedItem, 0)
					'intMode = 0
					ActionsPanel.RemoveViewFromParent
					Return True
				End If
			End If
			If intMode = -1 Then
				If (m.LeftOpen = False And EntryLeft >= 40dip) Or (m.LeftOpen = True And EntryLeft >= m.LeftMaxSwipe - 10dip) Then
					'sliding the panel to left as 0
					'LogColor($"...sliding back with index ${index}"$, Colors.Magenta)
					item.Panel.SetLayoutAnimated(200, 0, item.Panel.Top, item.Panel.Width, item.Panel.Height)
					m.IsRightSwiped = False
					m.RightOpen = False
					mapMode.Put(LastSwipedItem, 0)
					ActionsPanel.RemoveViewFromParent
					Return True
				End If
			End If
			'sliding the panel to show all right menu
			LogColor($"sliding with index ${index} full to show right menu..."$, Colors.Magenta)
			item.Panel.SetLayoutAnimated(200, -m.RightMaxSwipe, item.Panel.Top, item.Panel.Width, item.Panel.Height)
			m.RightOpen = True
			mapMode.Put(LastSwipedItem, 1)
		End If		
	Else
		item.Panel.Left = EntryLeft
	End If
	Return True
End Sub

Private Sub ChangeLeftOffset(index As Int, dx As Int, complete As Boolean) As Boolean
	If index < 0 Or index >= mCLV.Size Then 
		LogColor("ChangeLeftOffset: Return False 1", Colors.Red)
		Return False
	End If
	Dim item As CLVItem = mCLV.GetRawListItem(index)
	If Not(item.Value Is SwipeItem) Then 
		LogColor("ChangeLeftOffset: Return False 2", Colors.Red)
		Return False
	End If
	Dim m As SwipeItem = item.Value
	If m.IsLeftSwiped = False And complete = True Then 
		LogColor("ChangeLeftOffset: Return False 3", Colors.Red)
		Return False
	End If
	If m.IsLeftSwiped = False Then
		If m.leftActions.IsInitialized And m.leftActions.Size > 0 Then
			m.IsLeftSwiped = True			
			If ActionsPanel.Parent.IsInitialized Then ActionsPanel.RemoveViewFromParent
			item.Panel.Parent.AddView(ActionsPanel, 0, item.Panel.Top, item.Panel.Width, item.Panel.Height)
			ActionsPanel.SendToBack
			m.leftMaxSwipe = CreateLeftActionButtons(m.leftActions)
			LastSwipedItem = index
		Else
			LogColor("ChangeLeftOffset: Return False 4", Colors.Red)
			Return False
		End If
	End If
	EntryLeft = Min(Max(item.Panel.Left + dx, 0), m.leftMaxSwipe)
	'LogColor($"EntryLeft: ${EntryLeft}; is completed? ${complete}"$, Colors.Cyan)
	If complete Then
'		LogColor($"index: ${index} - ChangeLeftOffset's complete: ${complete}"$, Colors.Red)		
		If LastSwipedItem <> -1 Then
			If mapMode.ContainsKey(LastSwipedItem) = False Then
				Return False
			End If
			Dim intMode As Int = mapMode.Get(LastSwipedItem)
			If intMode = -1 Then
				If	(m.LeftOpen = False And EntryLeft <= 40dip) Or (m.LeftOpen = True And EntryLeft <= m.LeftMaxSwipe - 10dip) Then
					'sliding the panel to left
'					LogColor($"...sliding back (left) with index: ${index}"$, Colors.Blue)
					item.Panel.SetLayoutAnimated(200, 0, item.Panel.Top, item.Panel.Width, item.Panel.Height)
					m.IsLeftSwiped = False
					m.LeftOpen = False
					mapMode.Put(LastSwipedItem, 0)
					ActionsPanel.RemoveViewFromParent
					Return True
				End If
			End If
			If intMode = 1 Then
				If (m.RightOpen = False And EntryLeft >= -40dip) Or (m.RightOpen = True And EntryLeft >= -m.RightMaxSwipe + 10dip) Then
					'sliding the panel to left
'					LogColor($"...sliding back (right) with index: ${index}"$, Colors.Blue)
					item.Panel.SetLayoutAnimated(200, 0, item.Panel.Top, item.Panel.Width, item.Panel.Height)
					m.IsLeftSwiped = False
					m.LeftOpen = False
					mapMode.Put(LastSwipedItem, 0)
					ActionsPanel.RemoveViewFromParent
					Return True
				End If
			End If
			'sliding the panel to show all left menu
			LogColor($"sliding with index ${index} full to show left menu..."$, Colors.Blue)
			item.Panel.SetLayoutAnimated(200, m.leftMaxSwipe, item.Panel.Top, item.Panel.Width, item.Panel.Height)
			m.LeftOpen = True
			mapMode.Put(LastSwipedItem, -1)
		End If		
	Else
		item.Panel.Left = EntryLeft
	End If
	Return True
End Sub

Private Sub ChangeYOffset(dy As Int, complete As Boolean) 'ignore
	If WaitingForRefreshToComplete Then Return
	Dim NewTop As Int = Min(Max(mCLV.AsView.Top + dy, 0), mPullToRefreshPanel.Height)
	mCLV.AsView.Top = NewTop
	If NewTop = mPullToRefreshPanel.Height Then
		RaiseRefreshEvent
	End If
	If complete Then
		mCLV.AsView.SetLayoutAnimated(200, 0, 0, mCLV.AsView.Width, mCLV.AsView.Height)
	End If
End Sub

Private Sub RaiseRefreshEvent
	WaitingForRefreshToComplete = True
	HandlingSwipe = False
	CallSub(mCallback, mEventName & "_RefreshRequested")
End Sub

Public Sub ScrollChanged (offset As Int)
	#if B4i
	Dim sv As ScrollView = mCLV.sv
	Dim no As NativeObject = sv
	
	If offset <= 0 And mPullToRefreshPanel.IsInitialized Then
		sv.Bounces = True
		mPullToRefreshPanel.Visible = True
		no.RunMethod("setShowsVerticalScrollIndicator:", Array(False))
		If offset <= -mPullToRefreshPanel.Height Then
			sv.ScrollEnabled = False
			sv.ScrollTo(0, 0, False)
			mCLV.AsView.Top = mPullToRefreshPanel.Height
			RaiseRefreshEvent
			
		End If
	Else
		sv.Bounces = False
		no.RunMethod("setShowsVerticalScrollIndicator:", Array(True))
	End If
	#End If
	
End Sub

Public Sub RefreshCompleted
	If WaitingForRefreshToComplete = False Then Return
	WaitingForRefreshToComplete = False
	mPullToRefreshPanel.Visible = False
	mCLV.AsView.SetLayoutAnimated(200, 0, 0, mCLV.AsView.Width, mCLV.AsView.Height)
	#if B4i
	Dim sv As ScrollView = mCLV.sv
	sv.ScrollEnabled = True
	#End If
End Sub

Private Sub CreateRightActionButtons (actions As List) As Int
	LogColor("CreateRightActionButtons", Colors.Black)
	ActionsPanel.RemoveAllViews
	Dim LastX As Int = 0
	For Each action As String In actions
		Dim lb As Label
		lb.Initialize("lbl")
		Dim xl_bl As B4XView = lb
		xl_bl.Text = action
		xl_bl.Color = ActionColors.GetDefault(action, xui.Color_White)
		xl_bl.SetTextAlignment("CENTER", "CENTER")
		xl_bl.Font = xui.CreateDefaultBoldFont(20)
		xl_bl.TextColor = xui.Color_Black
		Dim width As Int = Max(40dip, cvs.MeasureText(action, xl_bl.Font).Width + 20dip)
		ActionsPanel.AddView(xl_bl, ActionsPanel.Width - width - LastX, 0, width, ActionsPanel.Height)
		LastX = LastX + width
	Next
	Return LastX
End Sub

Private Sub CreateLeftActionButtons (actions As List) As Int
	LogColor("CreateLeftActionButtons", Colors.Black)
	ActionsPanel.RemoveAllViews
	Dim LastX As Int = 0
	For Each action As String In actions
		Dim l As Label
		l.Initialize("lbl")
		Dim xlbl As B4XView = l
		xlbl.Text = action
		xlbl.Color = ActionColors.GetDefault(action, xui.Color_White)
		xlbl.SetTextAlignment("CENTER", "CENTER")
		xlbl.Font = xui.CreateDefaultBoldFont(20)
		xlbl.TextColor = xui.Color_Black
		Dim width As Int = Max(40dip, cvs.MeasureText(action, xlbl.Font).Width)
		'ActionsPanel.AddView(xlbl, ActionsPanel.Width - width - LastX, 0, width, ActionsPanel.Height)
		ActionsPanel.AddView(xlbl, LastX, 0, width, ActionsPanel.Height)
		LastX = LastX + width
	Next
	Return LastX
End Sub

Private Sub lbl_Click
	Dim lbl As B4XView = Sender
	Dim index As Int = LastSwipedItem
	CloseLastSwiped
	CallSub3(mCallback, mEventName & "_ActionClicked", index, lbl.Text)
End Sub

Public Sub CloseLastSwiped()
	If LastSwipedItem <> -1 Then
		If mapMode.ContainsKey(LastSwipedItem) = False Then
			Return
		End If
		Dim intMode As Int = mapMode.Get(LastSwipedItem)
		
		If intMode = -1 Then
			ChangeLeftOffset(LastSwipedItem, -10000dip, True)
			LastSwipedItem = -1
		End If
		If intMode = 1 Then
			ChangeRightOffset(LastSwipedItem, 10000dip, True)
			LastSwipedItem = -1
		End If
	End If
End Sub

Public Sub Resize(Width As Int, Height As Int)
	CloseLastSwiped
	ActionsPanel.Width = Width
	Base.SetLayoutAnimated(0, Base.Top, Base.Left, Width, Height)
	If mPullToRefreshPanel.IsInitialized Then
		mPullToRefreshPanel.SetLayoutAnimated(0, 0, 0, Width, mPullToRefreshPanel.Height)
	End If
End Sub

Public Sub setPullToRefreshPanel(pnl As B4XView)
	If pnl.Parent.IsInitialized Then pnl.RemoveViewFromParent
	If mPullToRefreshPanel.IsInitialized Then mPullToRefreshPanel.RemoveViewFromParent
	mPullToRefreshPanel = pnl
	Base.AddView(mPullToRefreshPanel, 0, 0, Base.Width, mPullToRefreshPanel.Height)
	mPullToRefreshPanel.SendToBack
	mPullToRefreshPanel.Visible = False
End Sub

Public Sub getPullToRefreshPanel As B4XView
	Return mPullToRefreshPanel
End Sub
#if B4A
Private Sub TouchPanel_OnInterceptTouchEvent (Action As Int, X As Float, Y As Float, MotionEvent As Object) As Boolean
	If HandlingSwipe Or WaitingForRefreshToComplete Then Return True
	Select Action
		Case Base.TOUCH_ACTION_DOWN
			TouchXStart = X
			TouchYStart = Y
			HandlingSwipe = False
		Case Base.TOUCH_ACTION_MOVE
			Dim dx As Float = Abs(x - TouchXStart)
			Dim dy As Float = Abs(y - TouchYStart)			
			'ScrollViewOffsetY = 0 means the position of customlistview is at most top			
			If mPullToRefreshPanel.IsInitialized And mCLV.sv.ScrollViewOffsetY = 0 And y - TouchYStart > 3dip Then
				HandlingSwipe = True
				PullToRefreshSwipe = True
				mPullToRefreshPanel.Visible = True
				CloseLastSwiped
			Else 
				If dy < 20dip And dx > 10dip Then
					If HandlingSwipe = False Then
						Dim NewSwipeItem As Int = mCLV.FindIndexFromOffset(TouchYStart + mCLV.sv.ScrollViewOffsetY)
						If X-TouchXStart < 0 Then
							'right side menu
							If NewSwipeItem <> -1 Then
								mapMode.Put(NewSwipeItem, 1)
							End If
						End If
						If X-TouchXStart > 0 Then
							'left side menu
							If NewSwipeItem <> -1 Then
								mapMode.Put(NewSwipeItem, -1)
							End If
						End If
						If X-TouchXStart = 0 Then
							'middle side without menu
							If NewSwipeItem <> -1 Then
								mapMode.Put(NewSwipeItem, 0)
							End If
						End If
						If NewSwipeItem <> LastSwipedItem Then 
							'LogColor("LastSwipedItem: " & LastSwipedItem & "; NewSwipeItem: " & NewSwipeItem, Colors.DarkGray)
							CloseLastSwiped
						End If
						LastSwipedItem = NewSwipeItem
					End If
					HandlingSwipe = True
					PullToRefreshSwipe = False
				End If
			End If
	End Select
	Return HandlingSwipe
End Sub

Private Sub TouchPanel_OnTouchEvent (Action As Int, X As Float, Y As Float, MotionEvent As Object) As Boolean
	If HandlingSwipe = False Or WaitingForRefreshToComplete Then Return True
	If PullToRefreshSwipe Then
		Select Action
			Case Base.TOUCH_ACTION_MOVE
				Dim dy As Float = y - TouchYStart
				TouchYStart = Y
				ChangeYOffset(dy, False)
			Case Base.TOUCH_ACTION_UP
				ChangeYOffset(dy, True)
				HandlingSwipe = False
		End Select
	Else		
		Select Action
			Case Base.TOUCH_ACTION_MOVE							
				Dim dx As Float = x - TouchXStart
'				LogColor("TouchPanel_OnTouchEvent: " & dx, Colors.Green)
				TouchXStart = X
				If dx < 0 Then
					'swipe to left i.e. right menu
					HandlingSwipe = ChangeRightOffset(LastSwipedItem, dx, False)
				Else
					If dx > 0 Then
						'swipe to right i.e. left menu
						HandlingSwipe = ChangeLeftOffset(LastSwipedItem, dx, False)
					End If
				End If				
			Case Base.TOUCH_ACTION_UP
'				LogColor("TOUCH_ACTION_UP", Colors.Green)				
				If LastSwipedItem <> -1 Then
					If mapMode.ContainsKey(LastSwipedItem) = False Then
						Return False
					End If
					Dim intMode As Int = mapMode.Get(LastSwipedItem)
					If intMode = -1 Then
						'swipe to right i.e. left menu
						ChangeLeftOffset(LastSwipedItem, 0dip, True)
'						LogColor("TOUCH_ACTION_UP 2", Colors.Green)
						HandlingSwipe = False
					End If
					If intMode = 1 Then
						'swipe to left i.e. right menu
						ChangeRightOffset(LastSwipedItem, 0dip, True)
'						LogColor("TOUCH_ACTION_UP 1", Colors.Green)
						HandlingSwipe = False
					End If
				End If				
		End Select
	End If
	Return True
End Sub
#end if

#if B4i
Private Sub Pan_Event (pan As Object)
	if WaitingForRefreshToComplete Then Return
	Dim rec As NativeObject = pan
	Dim points() As Float = rec.ArrayFromPoint(rec.RunMethod("locationInView:", Array(Base)))
	Dim x As Float = points(0)
	Dim state As Int = rec.GetField("state").AsNumber
	Select state
		Case 1 'began
			TouchXStart = x
			TouchYStart = points(1)
			If HandlingSwipe = False Then
				Dim NewSwipeItem As Int = mCLV.FindIndexFromOffset(TouchYStart + mCLV.sv.ScrollViewOffsetY)
				If NewSwipeItem <> LastSwipedItem Then CloseLastSwiped
				LastSwipedItem = NewSwipeItem
			End If
			HandlingSwipe = True
		Case 2 'changed
			Dim dx As Float = x - TouchXStart
			ChangeRightOffset(LastSwipedItem, dx, False)
			TouchXStart = X
		Case 3 'ended
			HandlingSwipe = False
			ChangeRightOffset(LastSwipedItem, 0, True)
	End Select
End Sub
#end if

#if OBJC
- (NSObject*) CreateRecognizer{
 	 UIPanGestureRecognizer *rec = [[UIPanGestureRecognizer alloc] initWithTarget:self action:@selector(action:)];
    [rec setMinimumNumberOfTouches:1];
    [rec setMaximumNumberOfTouches:1];
	return rec;
}
-(void) action:(UIPanGestureRecognizer*)rec {
	[self.bi raiseEvent:nil event:@"pan_event:" params:@[rec]];
}
#End If

